// ChildView.cpp : implementation of the CChildView class
//

#include "Stdafx.h"
#include "PropCom.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
	bComPortSelected = FALSE;
	bPropertiesBoxShown = FALSE;
}

CChildView::~CChildView()
{
}

BEGIN_MESSAGE_MAP(CChildView,CWnd)
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_BTNFACE + 1), NULL);

	return TRUE;
}

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd ::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// Create the output rich edit control
	VERIFY(m_wndOutputRichEditCtrl.Create(WS_VISIBLE|WS_HSCROLL
		| WS_VSCROLL|WS_CHILD|ES_AUTOHSCROLL|ES_AUTOVSCROLL
		|ES_WANTRETURN|ES_LEFT|ES_MULTILINE,CRect(0,0,0,0),this,0));

	m_wndOutputRichEditCtrl.ShowScrollBar(SB_HORZ);
	
	return 0;
}

void CChildView::OnSize(UINT nType, int cx, int cy) 
{
	CWnd ::OnSize(nType, cx, cy);
	
	// Size the output rich edit control to view size
//	m_wndOutputRichEditCtrl.SetWindowPos(0,0,0,cx,cy,
//		SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOZORDER);
}

void CChildView::OnSetFocus(CWnd* pOldWnd) 
{
	CWnd ::OnSetFocus(pOldWnd);
	
	// Pass focus to the output rich edit control
	m_wndOutputRichEditCtrl.SetFocus();
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this);

	if(bComPortSelected == FALSE && bPropertiesBoxShown == TRUE)
	{
		CRect rect;
		GetClientRect (&rect);

		dc.SetTextColor(RGB(255, 0, 0));
		dc.SetBkColor(GetSysColor(COLOR_BTNFACE));
		dc.DrawText (_T("No Communication Port Selected!"), -1, &rect,
        DT_VCENTER | DT_CENTER | DT_SINGLELINE);
	}
}
