// ClipListDlg.cpp : implementation file
//

#include "Stdafx.h"
#include "PropCom.h"
#include "ClipListDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClipListDlg dialog


CClipListDlg::CClipListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClipListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClipListDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CClipListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClipListDlg)
	DDX_Control(pDX, IDC_EDIT, m_Edit);
	DDX_Control(pDX, IDC_CLIPLIST, m_ClipList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClipListDlg, CDialog)
	//{{AFX_MSG_MAP(CClipListDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHANGE_CLIP_LIST, OnChangeClipList)
	ON_LBN_SELCHANGE(IDC_CLIPLIST, OnSelchangeCliplist)
	ON_BN_CLICKED(IDC_HELPBUTT, OnHelpbutt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClipListDlg message handlers

BOOL CClipListDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_Edit.MoveWindow(0, 0, 0, 0, FALSE);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	pSysMenu->RemoveMenu(SC_MOVE, MF_BYCOMMAND);

	SetIcon(m_hIcon, FALSE);
	
	return TRUE;
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClipListDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClipListDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CClipListDlg::OnChangeClipList() 
{
CFileDialog dlg(TRUE, _T("txt"), _T("*.txt"), NULL,
		_T("Text Files(*.txt)|*.txt||"));

	dlg.m_ofn.lpstrInitialDir = fs.szDesktopDir;
	dlg.m_ofn.lpstrTitle = _T("Change List");

	if(dlg.DoModal() == IDOK)
	{
		CString strListPath = dlg.GetPathName();

		m_ClipList.ResetContent();
		strClipList.RemoveAll();

		CString strFileline;
		CStdioFile file;
		file.Open(strListPath, CFile::modeRead);

		int nCount = 0;

		while(file.ReadString(strFileline))
		{
			if(strFileline != _T(""))
			{
				int nIndex = strFileline.Find(_T("\\"));
				if(nIndex != 0 && nIndex < 31)
				{
					m_ClipList.AddString(strFileline.Mid(0, nIndex));
					strFileline.Delete(0, nIndex + 1);
					strClipList.AddTail(strFileline);
					nCount++;
				}				
			}
		}
		file.Close();
	}	
}

void CClipListDlg::OnSelchangeCliplist() 
{
	int nIndex = m_ClipList.GetCurSel();
	m_Edit.SetWindowText(strClipList.GetAt(strClipList.FindIndex(nIndex)));
	m_Edit.SetSel(0, -1, FALSE);
	m_Edit.Copy();	
}

void CClipListDlg::OnHelpbutt() 
{
	TCHAR szPath[MAX_PATH] = _T("");
	strcpy(szPath, fs.szDesktopDir);
	fs.PathAppend_FS(szPath, _T("\\ClipList Instructions.txt"));
	fs.WriteCustomResourceFromExe_FS(IDR_INSTRUCTIONS, _T("TEXT"), szPath, TRUE);

	ShellExecute(NULL, "open", szPath,
		NULL, 0, SW_SHOWNORMAL);
}
