// ComPortSettingsPage.cpp : implementation file
//

#include "Stdafx.h"
#include "PropCom.h"
#include "ComPortSettingsPage.h"
#include "Serial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CComPortSettingsPage property page

IMPLEMENT_DYNCREATE(CComPortSettingsPage, CPropertyPage)

CComPortSettingsPage::CComPortSettingsPage() : CPropertyPage(CComPortSettingsPage::IDD)
{
	//{{AFX_DATA_INIT(CComPortSettingsPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CComPortSettingsPage::~CComPortSettingsPage()
{
}

void CComPortSettingsPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CComPortSettingsPage)
	DDX_Control(pDX, IDC_EDIT_EVENT_CHARACTER, m_wndEventCharacter);
	DDX_Control(pDX, IDC_COMBO_COM_PORT, m_wndComPort);
	DDX_Control(pDX, IDC_COMBO_STOP_BITS, m_wndStopBits);
	DDX_Control(pDX, IDC_COMBO_PARITY, m_wndParity);
	DDX_Control(pDX, IDC_COMBO_FLOW_CONTROL, m_wndFlowControl);
	DDX_Control(pDX, IDC_COMBO_DATA_BITS, m_wndDataBits);
	DDX_Control(pDX, IDC_COMBO_BAUD_RATE, m_wndBaudRate);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CComPortSettingsPage, CPropertyPage)
	//{{AFX_MSG_MAP(CComPortSettingsPage)
	ON_EN_CHANGE(IDC_EDIT_EVENT_CHARACTER, OnChangeEditEventCharacter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComPortSettingsPage message handlers

BOOL CComPortSettingsPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	m_wndEventCharacter.SetLimitText(3);

	//Check for availability of COM ports 1-9
	for(int i = 0; i < 10; i++ )
	{
		CString strAvailableComPort;
		strAvailableComPort = "COM";

		TCHAR szIteration[MAX_PATH] = _T("");
		itoa(i, szIteration, 10);

		strAvailableComPort += (LPCTSTR)szIteration;	

		if(CSerial::CheckPort(strAvailableComPort) == CSerial::EPortAvailable)
		{
			m_wndComPort.AddString(strAvailableComPort);
		}
	}
	
	return TRUE;
}

BOOL CComPortSettingsPage::OnSetActive() 
{
	m_wndComPort.SetCurSel(0);
	m_wndBaudRate.SetCurSel(12);
	m_wndDataBits.SetCurSel(3);
	m_wndParity.SetCurSel(0);
	m_wndStopBits.SetCurSel(0);	
	m_wndFlowControl.SetCurSel(0);	
	
	return CPropertyPage::OnSetActive();
}

void CComPortSettingsPage::OnChangeEditEventCharacter() 
{
	if(GetDlgItemInt(IDC_EDIT_EVENT_CHARACTER) > 255)
	{
		MessageBox("The event character must have a decimal value between 0 and 255!", "ERROR", MB_ICONERROR);
		m_wndEventCharacter.SetSel(0, -1);
		m_wndEventCharacter.Clear();
	}
}
