// FileServices.h: interface for the CFileServices class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILESERVICES_H__5DBE30E0_89CF_11D7_A72F_A35BBEF5307B__INCLUDED_)
#define AFX_FILESERVICES_H__5DBE30E0_89CF_11D7_A72F_A35BBEF5307B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
//////////////////////////////////////////////////////////////////////
#define SETPOINT(pt, h, v) { (pt).x=h; (pt).y=v; }

#pragma pack(push)
#pragma pack(2)

typedef struct
{
	BYTE bWidth;
	BYTE bHeight;
	BYTE bColorCount;
	BYTE bReserved;
	WORD wPlanes;
	WORD wBitCount;
	DWORD dwBytesInRes;
	WORD nID;

} MEMICONDIRENTRY, *LPMEMICONDIRENTRY;

typedef struct 
{
	WORD idReserved;
	WORD idType;
	WORD idCount;
	MEMICONDIRENTRY	idEntries[1];

} MEMICONDIR, *LPMEMICONDIR;

#pragma pack(pop)

typedef struct
{
	BYTE bWidth;
	BYTE bHeight;
	BYTE bColorCount;
	BYTE bReserved;
	WORD wPlanes;
	WORD wBitCount;
	DWORD dwBytesInRes;
	DWORD dwImageOffset;

} ICONDIRENTRY, *LPICONDIRENTRY;

typedef struct
{
	UINT Width;
	UINT Height;
	UINT Colors;
	LPBYTE lpBits;
	DWORD dwNumBytes;
	LPBITMAPINFO lpbi;
	LPBYTE lpXOR;
	LPBYTE lpAND;

} ICONIMAGE, *LPICONIMAGE;

typedef struct
{
	UINT nNumImages;
	ICONIMAGE IconImages[1];

} ICONRESOURCE, *LPICONRESOURCE;

typedef struct
{
	CStringList* strList;
	WINDOWPLACEMENT wndpl;

} MYCUSTOMDATA, *LPMYCUSTOMDATA;
//////////////////////////////////////////////////////////////////////

class CFileServices  
{
public:
	TCHAR szWindowsDir[MAX_PATH];
	TCHAR szMainDrive[MAX_PATH];
	TCHAR szProgramFilesDir[MAX_PATH];
	TCHAR szProgramsDir[MAX_PATH];
	TCHAR szDesktopDir[MAX_PATH];
	TCHAR szStartupDir[MAX_PATH];
	TCHAR szStartMenuDir[MAX_PATH];
	TCHAR szMyDocumentsDir[MAX_PATH];
	TCHAR szFavoritesDir[MAX_PATH];

	BOOL CloseAppNow(LPTSTR szRunningApp);
	BOOL PathStripToRoot_FS(LPTSTR szRoot);
	BOOL PathRenameExtension_FS(LPTSTR pszPath, LPCTSTR pszExt);
	BOOL PathRemoveFileSpec_FS(LPTSTR pszPath);
	void PathRemoveExtension_FS(LPTSTR pszPath);
	void PathRemoveArgs_FS(LPTSTR pszPath);
	BOOL PathIsFileSpec_FS(LPTSTR pszPath);
	BOOL PathIsDirectory_FS(LPTSTR pszPath);
	LPTSTR PathGetArgs_FS(LPTSTR pszPath);
	BOOL PathFileExists_FS(LPTSTR pszPath);
	BOOL PathAddExtension_FS(LPTSTR pszPath, LPCTSTR pszExtension);
	BOOL MoveFile_FS(LPTSTR lpExistingFileName, LPTSTR lpNewFileName);
	BOOL CopyFile_FS(LPTSTR lpExistingFileName, LPTSTR lpNewFileName, BOOL bFailIfExists);
	BOOL RemoveDirectory_FS(LPTSTR lpszDirPath);
	BOOL PathAppend_FS(LPTSTR pszPath, LPCTSTR pszMore);
	LPTSTR PathRemoveBackslash_FS(LPTSTR lpszPath);
	LPTSTR PathAddBackslash_FS(LPTSTR lpszPath);
	BOOL DeleteFile_FS(LPTSTR lpFileName);
	void DeleteDirectory_FS(LPTSTR szDirectoryPath);
	BOOL CreateDirectory_FS(LPTSTR lpszDirPath);
	BOOL InitializeDirPaths_FS();
	void WriteIconResourceFromExe_FS(UINT idIcon, LPTSTR szPath);
	void WriteBitmapResourceFromExe_FS(UINT idBitmap, LPTSTR szPath);
	void WriteCustomResourceFromExe_FS(UINT idCustom, LPCTSTR lpszCustomType, LPTSTR szPath, BOOL bBinary);
	BOOL CreateInternetShortcut_FS(LPTSTR lpszLinkFile, LPCTSTR lpszURL, LPTSTR lpszIconFile, UINT idIcon);
	BOOL CreateShellLink_FS(LPTSTR lpszLinkFile, LPTSTR lpszLinkPath, LPTSTR lpszIconFile, UINT idIcon, LPCTSTR pszCmdLineArgs);
	CFileServices();
	virtual ~CFileServices();
};

#endif // !defined(AFX_FILESERVICES_H__5DBE30E0_89CF_11D7_A72F_A35BBEF5307B__INCLUDED_)
