// MainFrm.cpp : implementation of the CMainFrame class
//
#include "Stdafx.h"
#include "PropCom.h"
#include "MainFrm.h"
#include "PropComColorDialog.h"
#include "ClipListDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

static UINT WM_FINDREPLACE = RegisterWindowMessage(FINDMSGSTRING);

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_SENDFILE, OnSendfile)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_NEW_TERMINAL, OnNewTerminal)
	ON_COMMAND(ID_SEND_BREAK, OnSendBreak)
	ON_COMMAND(ID_FONT_COLOR, OnFontColor)
	ON_COMMAND(ID_BACKGROUND_COLOR, OnBackgroundColor)
	ON_COMMAND(ID_OPEN_CLIPLIST, OnOpenCliplist)
	ON_COMMAND(ID_CLEAR_INPUT, OnClearInput)
	ON_COMMAND(ID_CLEAR_OUTPUT, OnClearOutput)
	ON_COMMAND(ID_VIEW_PIN_STATUS_BAR, OnViewPinStatusBar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PIN_STATUS_BAR, OnUpdateViewPinStatusBar)
	ON_COMMAND(ID_EDIT_FIND, OnEditFind)		
	ON_COMMAND(ID_STOP, OnStop)	
	ON_WM_GETMINMAXINFO()
	ON_COMMAND(IDC_RUN1, OnRun1)
	ON_COMMAND(IDC_RUN2, OnRun2)
	ON_COMMAND(IDC_RUN3, OnRun3)
	ON_COMMAND(IDC_RUN4, OnRun4)
	ON_COMMAND(IDC_RUN5, OnRun5)
	ON_COMMAND(IDC_RUN6, OnRun6)
	ON_COMMAND(IDC_RUN7, OnRun7)
	ON_COMMAND(IDC_RUN8, OnRun8)
	ON_COMMAND(IDC_RUN9, OnRun9)
	ON_COMMAND(ID_VIEW_MULTIFILE_BAR, OnViewMultifileBar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_MULTIFILE_BAR, OnUpdateViewMultifileBar)
	ON_COMMAND(ID_CONFIGURE_SETTINGS, OnConfigureSettings)
	ON_COMMAND(ID_OPEN_DIFFERENT_PORT, OnOpenDifferentPort)
	ON_UPDATE_COMMAND_UI(ID_STOP, OnUpdateStop)
	ON_UPDATE_COMMAND_UI(IDC_RUN1, OnUpdateRun1)
	ON_UPDATE_COMMAND_UI(IDC_RUN2, OnUpdateRun2)
	ON_UPDATE_COMMAND_UI(IDC_RUN3, OnUpdateRun3)
	ON_UPDATE_COMMAND_UI(IDC_RUN4, OnUpdateRun4)
	ON_UPDATE_COMMAND_UI(IDC_RUN5, OnUpdateRun5)
	ON_UPDATE_COMMAND_UI(IDC_RUN6, OnUpdateRun6)
	ON_UPDATE_COMMAND_UI(IDC_RUN7, OnUpdateRun7)
	ON_UPDATE_COMMAND_UI(IDC_RUN8, OnUpdateRun8)
	ON_UPDATE_COMMAND_UI(IDC_RUN9, OnUpdateRun9)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_UPDATE_COMMAND_UI(ID_OPEN_CLIPLIST, OnUpdateOpenCliplist)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FIND, OnUpdateEditFind)
	ON_UPDATE_COMMAND_UI(ID_CLEAR_INPUT, OnUpdateClearInput)
	ON_UPDATE_COMMAND_UI(ID_CLEAR_OUTPUT, OnUpdateClearOutput)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FONT_COLOR, OnUpdateFontColor)
	ON_UPDATE_COMMAND_UI(ID_BACKGROUND_COLOR, OnUpdateBackgroundColor)
	ON_UPDATE_COMMAND_UI(ID_SEND_BREAK, OnUpdateSendBreak)
	ON_UPDATE_COMMAND_UI(ID_SENDFILE, OnUpdateSendfile)
	ON_WM_KEYDOWN()	
	ON_UPDATE_COMMAND_UI(ID_NEW_TERMINAL, OnUpdateNewTerminal)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(WM_FINDREPLACE, OnFindReplace)
	ON_NOTIFY_EX_RANGE(TTN_NEEDTEXT,0,0xFFFF,OnToolTipNotify)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	cfText.cbSize = sizeof(CHARFORMAT);
	cfText.dwMask = CFM_COLOR | CFM_FACE | CFM_SIZE | CFM_CHARSET | CFM_BOLD;
	cfText.dwEffects = CFE_BOLD;
    cfText.yHeight = 200; 
    cfText.crTextColor = RGB(0, 0, 0); 
    cfText.bCharSet = ANSI_CHARSET; 
    cfText.bPitchAndFamily = FF_ROMAN;
	lstrcpy(cfText.szFaceName,"Arial");

	bToolbarsCreated = FALSE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	SetIcon(LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME)), false);

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1; // Failed to create view window
	}
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1; // Failed to create toolbar
	}

	if (!m_wndMultiFileBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndMultiFileBar.LoadToolBar(IDR_MULTIFILE))
	{
		TRACE0("Failed to create multi-file bar\n");
		return -1; // Failed to create multi-file bar
	}	

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1; // Failed to create status bar
	}		

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	m_wndMultiFileBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndMultiFileBar);

	CRect rect;
	m_wndMultiFileBar.GetWindowRect(&rect);
	rect.OffsetRect(1, 0);
	this->RecalcLayout();
	
	DockControlBar(&m_wndMultiFileBar, AFX_IDW_DOCKBAR_TOP, &rect);

	m_wndMultiFileBar.GetToolBarCtrl().SetState(IDC_RUN1, TBSTATE_INDETERMINATE);
	m_wndMultiFileBar.GetToolBarCtrl().SetState(IDC_RUN2, TBSTATE_INDETERMINATE);
	m_wndMultiFileBar.GetToolBarCtrl().SetState(IDC_RUN3, TBSTATE_INDETERMINATE);
	m_wndMultiFileBar.GetToolBarCtrl().SetState(IDC_RUN4, TBSTATE_INDETERMINATE);
	m_wndMultiFileBar.GetToolBarCtrl().SetState(IDC_RUN5, TBSTATE_INDETERMINATE);
	m_wndMultiFileBar.GetToolBarCtrl().SetState(IDC_RUN6, TBSTATE_INDETERMINATE);
	m_wndMultiFileBar.GetToolBarCtrl().SetState(IDC_RUN7, TBSTATE_INDETERMINATE);
	m_wndMultiFileBar.GetToolBarCtrl().SetState(IDC_RUN8, TBSTATE_INDETERMINATE);
	m_wndMultiFileBar.GetToolBarCtrl().SetState(IDC_RUN9, TBSTATE_INDETERMINATE);

	bShowMultiFileBar = TRUE;

	if (!m_wndInputDlgBar.Create(this, IDR_MAINFRAME, 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create dialogbar\n");
		return -1; // Failed to create dialogbar
	}

	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndInputDlgBar))
	{
		TRACE0("Failed to create rebar\n");
		return -1; // Failed to create rebar
	}

	if (!m_wndPinStateDlgBar.Create(this, IDD_PIN_STATE, 
		CBRS_ALIGN_BOTTOM, IDD_PIN_STATE))
	{
		TRACE0("Failed to create pin state dialogbar\n");
		return -1; // Failed to create pin state dialogbar
	}	

	m_wndPinStateDlgBar.EnableDocking(CBRS_ALIGN_BOTTOM);
	EnableDocking(CBRS_ALIGN_BOTTOM);
	DockControlBar(&m_wndPinStateDlgBar);

	bShowPinStateDlgBar = TRUE;	

	CRect rcInputDlgBar;
	GetClientRect(&rcInputDlgBar);

	CRichEditCtrl* 	p_wndInputRichEditCtrl;
	p_wndInputRichEditCtrl = (CRichEditCtrl*)m_wndInputDlgBar.GetDlgItem(IDC_TERMINAL_INPUT);

	p_wndInputRichEditCtrl->SetWindowPos(NULL, rcInputDlgBar.left, rcInputDlgBar.top + 8,
		rcInputDlgBar.Width() - 17, (GetSystemMetrics(SM_CYHSCROLL) * 2) + 8, SWP_NOZORDER | SWP_SHOWWINDOW);

	p_wndInputRichEditCtrl->SetDefaultCharFormat(cfText);
	
	p_wndInputRichEditCtrl->ShowScrollBar(SB_HORZ, TRUE);	

	m_wndView.m_wndOutputRichEditCtrl.SetDefaultCharFormat(cfText);
	m_wndView.m_wndOutputRichEditCtrl.ShowScrollBar(SB_BOTH, TRUE);

	OnViewPinStatusBar(); //This will initially hide the pin status bar
//	OnViewMultifileBar(); //This will initially hide the multi-file bar

	bToolbarsCreated = TRUE;

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if(!CFrameWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);

	cs.cx = 618;  //Set initial minimum window width
	cs.cy = 416;  //Set initial minimum window height

	return TRUE;
}

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	lpMMI->ptMinTrackSize.x = 618;  //Set constant minimum window width
	lpMMI->ptMinTrackSize.y = 416;  //Set constant minimum window height	

	CFrameWnd::OnGetMinMaxInfo(lpMMI);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CMainFrame::RecalcLayout(BOOL bNotify) 
{
	if(bToolbarsCreated == TRUE)
	{
		CRect rcInputDlgBar;
		GetClientRect(&rcInputDlgBar);

		CWnd*	p_wndInputRichEditCtrl;
		p_wndInputRichEditCtrl = m_wndInputDlgBar.GetDlgItem(IDC_TERMINAL_INPUT);

		p_wndInputRichEditCtrl->SetWindowPos(NULL, rcInputDlgBar.left,
			rcInputDlgBar.top + 8, rcInputDlgBar.Width() - 17, (GetSystemMetrics(SM_CYHSCROLL) * 2) + 8,
			SWP_NOZORDER | SWP_SHOWWINDOW);

		p_wndInputRichEditCtrl->ShowScrollBar(SB_HORZ, TRUE);
	}

	CFrameWnd::RecalcLayout(bNotify);
}

void CMainFrame::OnViewPinStatusBar() 
{
	if(bShowPinStateDlgBar == TRUE)
	{
		ShowControlBar((CControlBar*)&m_wndPinStateDlgBar, FALSE, TRUE);
		bShowPinStateDlgBar = FALSE;
	}
	else
	{
		ShowControlBar((CControlBar*)&m_wndPinStateDlgBar, TRUE, TRUE);
		bShowPinStateDlgBar = TRUE;
	}
}

void CMainFrame::OnUpdateViewPinStatusBar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(bShowPinStateDlgBar);	
}

void CMainFrame::OnViewMultifileBar() 
{
	if(bShowMultiFileBar == TRUE)
	{
		ShowControlBar((CControlBar*)&m_wndMultiFileBar, FALSE, TRUE);
		bShowMultiFileBar = FALSE;
	}
	else
	{
		ShowControlBar((CControlBar*)&m_wndMultiFileBar, TRUE, TRUE);
		bShowMultiFileBar = TRUE;
	}
}

void CMainFrame::OnUpdateViewMultifileBar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(bShowMultiFileBar);
}

void CMainFrame::UpdatePin0(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin0.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin0.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin1(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin1.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin1.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin2(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin2.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin2.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin3(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin3.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin3.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin4(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin4.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin4.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin5(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin5.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin5.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin6(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin6.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin6.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin7(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin7.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin7.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin8(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin8.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin8.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin9(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin9.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin9.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin10(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin10.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin10.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin11(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin11.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin11.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin12(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin12.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin12.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin13(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin13.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin13.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin14(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin14.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin14.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin15(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin15.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin15.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin16(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin16.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin16.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin17(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin17.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin17.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin18(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin18.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin18.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin19(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin19.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin19.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin20(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin20.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin20.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin21(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin21.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin21.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin22(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin22.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin22.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin23(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin23.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin23.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin24(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin24.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin24.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin25(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin25.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin25.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin26(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin26.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin26.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin27(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin27.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin27.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin28(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin28.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin28.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin29(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin29.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin29.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin30(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin30.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin30.SetLed(16, 0, 0);
	}	
}

void CMainFrame::UpdatePin31(int nState)
{
	if(nState == 0)
	{
		m_wndPinStateDlgBar.m_Pin31.SetLed(16, 1, 0);
	}
	else
	{
		m_wndPinStateDlgBar.m_Pin31.SetLed(16, 0, 0);
	}	
}


BOOL CMainFrame::OnToolTipNotify(UINT id, NMHDR* pNMHDR, LRESULT* pResult )
{
	//Initialize the TOOLTIPTEXT structure.
	TOOLTIPTEXT *pTTip = (TOOLTIPTEXT *)pNMHDR;

	// idFrom contains the resource identifier for the toolbars buttons.
	UINT ResourceID = pNMHDR->idFrom;

	//The toolbar buttons needed have resource ID's between 32791 and 32799.
	if(ResourceID > 32790 && ResourceID < 32800)
	{
		TCHAR szToolTipText[MAX_PATH] = _T("");
		CString strStatusBarText;

		strStatusBarText = "Run File: ";
			
		switch(ResourceID)
		{
		case IDC_RUN1:

			if(m_strFileTitle1 != "")
			{
				// Set the tooltip text for button #1.
				lstrcpy(szToolTipText, m_strFileTitle1);
				pTTip->lpszText = szToolTipText;

				//Also update status bar
				strStatusBarText += m_strFileTitle1;
				m_wndStatusBar.SetPaneText(0, strStatusBarText, TRUE);				
			}

			break;

		case IDC_RUN2:

			if(m_strFileTitle2 != "")
			{
				// Set the tooltip text for button #2.
				lstrcpy(szToolTipText, m_strFileTitle2);
				pTTip->lpszText = szToolTipText;

				//Also update status bar
				strStatusBarText += m_strFileTitle2;
				m_wndStatusBar.SetPaneText(0, strStatusBarText, TRUE);
			}

			break;

		case IDC_RUN3:

			if(m_strFileTitle3 != "")
			{
				// Set the tooltip text for button #3.
				lstrcpy(szToolTipText, m_strFileTitle3);
				pTTip->lpszText = szToolTipText;

				//Also update status bar
				strStatusBarText += m_strFileTitle3;
				m_wndStatusBar.SetPaneText(0, strStatusBarText, TRUE);
			}

			break;

		case IDC_RUN4:

			if(m_strFileTitle4 != "")
			{
				// Set the tooltip text for button #4.
				lstrcpy(szToolTipText, m_strFileTitle4);
				pTTip->lpszText = szToolTipText;

				//Also update status bar
				strStatusBarText += m_strFileTitle4;
				m_wndStatusBar.SetPaneText(0, strStatusBarText, TRUE);
			}

			break;

		case IDC_RUN5:

			if(m_strFileTitle5 != "")
			{
				// Set the tooltip text for button #5.
				lstrcpy(szToolTipText, m_strFileTitle5);
				pTTip->lpszText = szToolTipText;

				//Also update status bar
				strStatusBarText += m_strFileTitle5;
				m_wndStatusBar.SetPaneText(0, strStatusBarText, TRUE);
			}

			break;

		case IDC_RUN6:

			if(m_strFileTitle6 != "")
			{
				// Set the tooltip text for button #6.
				lstrcpy(szToolTipText, m_strFileTitle6);
				pTTip->lpszText = szToolTipText;

				//Also update status bar
				strStatusBarText += m_strFileTitle6;
				m_wndStatusBar.SetPaneText(0, strStatusBarText, TRUE);
			}

			break;

		case IDC_RUN7:

			if(m_strFileTitle7 != "")
			{
				// Set the tooltip text for button #7.
				lstrcpy(szToolTipText, m_strFileTitle7);
				pTTip->lpszText = szToolTipText;

				//Also update status bar
				strStatusBarText += m_strFileTitle7;
				m_wndStatusBar.SetPaneText(0, strStatusBarText, TRUE);
			}

			break;

		case IDC_RUN8:

			if(m_strFileTitle8 != "")
			{
				// Set the tooltip text for button #8.
				lstrcpy(szToolTipText, m_strFileTitle8);
				pTTip->lpszText = szToolTipText;

				//Also update status bar
				strStatusBarText += m_strFileTitle8;
				m_wndStatusBar.SetPaneText(0, strStatusBarText, TRUE);
			}

			break;

		case IDC_RUN9:

			if(m_strFileTitle9 != "")
			{
				// Set the tooltip text for button #9.
				lstrcpy(szToolTipText, m_strFileTitle9);
				pTTip->lpszText = szToolTipText;

				//Also update status bar
				strStatusBarText += m_strFileTitle9;
				m_wndStatusBar.SetPaneText(0, strStatusBarText, TRUE);
			}

			break;
		}
		return TRUE;
	}
	return FALSE;
}

void CMainFrame::StartupConfigureSettings()
{
	OnConfigureSettings();
}

void CMainFrame::OnOpenDifferentPort() 
{
	OnConfigureSettings();	
}

///////////////////////////////////////////////////
// In order to maintain some type of structure,
// toolbar and update handlers will be listed here
// in order of appearance.
///////////////////////////////////////////////////

void CMainFrame::OnEditCopy() 
{
	CString strInputCopy;
	CString strOutputCopy;

	CRichEditCtrl* p_wndInputRichEditCtrl;
	p_wndInputRichEditCtrl = (CRichEditCtrl*)m_wndInputDlgBar.GetDlgItem(IDC_TERMINAL_INPUT);

	if(p_wndInputRichEditCtrl->GetSelText() != "")
	{
		p_wndInputRichEditCtrl->Copy();
		p_wndInputRichEditCtrl->SetSel(0, 0);
	}

	if(m_wndView.m_wndOutputRichEditCtrl.GetSelText() != "")
	{
		m_wndView.m_wndOutputRichEditCtrl.Copy();
		m_wndView.m_wndOutputRichEditCtrl.SetSel(0, 0);
	}	
}

void CMainFrame::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnEditPaste() 
{
	CRichEditCtrl* p_wndInputRichEditCtrl;
	p_wndInputRichEditCtrl = (CRichEditCtrl*)m_wndInputDlgBar.GetDlgItem(IDC_TERMINAL_INPUT);
	p_wndInputRichEditCtrl->Paste();	
}

void CMainFrame::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnOpenCliplist() 
{
	CClipListDlg dlgClipList;
	dlgClipList.DoModal();	
}

void CMainFrame::OnUpdateOpenCliplist(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnEditFind() 
{
	CFindReplaceDialog* m_pFindDlg;

	m_pFindDlg = new CFindReplaceDialog;
	m_pFindDlg->Create(TRUE, "", NULL, FR_DOWN, this);
	m_pFindDlg->CenterWindow();

	CMenu* pSysMenu = m_pFindDlg->GetSystemMenu(FALSE);
	pSysMenu->RemoveMenu(SC_MOVE, MF_BYCOMMAND);
}

void CMainFrame::OnUpdateEditFind(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

LRESULT CMainFrame::OnFindReplace(WPARAM wParam, LPARAM lParam)
{
    if (((LPFINDREPLACE)lParam)->Flags & FR_FINDNEXT)
    {
        CString temp = "Search string: ";
        temp = temp + ((LPFINDREPLACE)lParam)->lpstrFindWhat;
        AfxMessageBox(temp);
    }

    return 0;
}

void CMainFrame::OnClearInput() 
{
	CRichEditCtrl* p_wndInputRichEditCtrl;
	p_wndInputRichEditCtrl = (CRichEditCtrl*)m_wndInputDlgBar.GetDlgItem(IDC_TERMINAL_INPUT);
	p_wndInputRichEditCtrl->SetSel(0, -1);
	p_wndInputRichEditCtrl->Clear();
	p_wndInputRichEditCtrl->SetScrollPos(0, FALSE);
	p_wndInputRichEditCtrl->SetScrollRange(0, 0, TRUE);
	p_wndInputRichEditCtrl->ShowScrollBar(SB_HORZ, TRUE);	
}

void CMainFrame::OnUpdateClearInput(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnClearOutput() 
{
	m_wndView.m_wndOutputRichEditCtrl.SetSel(0, -1);
	m_wndView.m_wndOutputRichEditCtrl.Clear();
	m_wndView.m_wndOutputRichEditCtrl.SetScrollPos(0, FALSE);
	m_wndView.m_wndOutputRichEditCtrl.SetScrollRange(0, 0, TRUE);
	m_wndView.m_wndOutputRichEditCtrl.ShowScrollBar(SB_BOTH, TRUE);	
}

void CMainFrame::OnUpdateClearOutput(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnFilePrint() 
{
}

void CMainFrame::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnConfigureSettings() 
{
	CPropComPropertySheet ps(_T("PropCom Properties And Settings"));

	ps.m_SecondPage.m_strFilePath1 = m_strFilePath1;
	ps.m_SecondPage.m_strFileTitle1 = m_strFileTitle1;
	ps.m_SecondPage.m_strFilePath2 = m_strFilePath2;
	ps.m_SecondPage.m_strFileTitle2 = m_strFileTitle2;
	ps.m_SecondPage.m_strFilePath3 = m_strFilePath3;
	ps.m_SecondPage.m_strFileTitle3 = m_strFileTitle3;
	ps.m_SecondPage.m_strFilePath4 = m_strFilePath4;
	ps.m_SecondPage.m_strFileTitle4 = m_strFileTitle4;
	ps.m_SecondPage.m_strFilePath5 = m_strFilePath5;
	ps.m_SecondPage.m_strFileTitle5 = m_strFileTitle5;
	ps.m_SecondPage.m_strFilePath6 = m_strFilePath6;
	ps.m_SecondPage.m_strFileTitle6 = m_strFileTitle6;
	ps.m_SecondPage.m_strFilePath7 = m_strFilePath7;
	ps.m_SecondPage.m_strFileTitle7 = m_strFileTitle7;
	ps.m_SecondPage.m_strFilePath8 = m_strFilePath8;
	ps.m_SecondPage.m_strFileTitle8 = m_strFileTitle8;
	ps.m_SecondPage.m_strFilePath9 = m_strFilePath9;
	ps.m_SecondPage.m_strFileTitle9 = m_strFileTitle9;

	ps.UpdateData();

	if(ps.DoModal() == IDOK)
	{
		m_strFilePath1 = ps.m_SecondPage.m_strFilePath1;
		m_strFileTitle1 = ps.m_SecondPage.m_strFileTitle1;
		m_strFilePath2 = ps.m_SecondPage.m_strFilePath2;
		m_strFileTitle2 = ps.m_SecondPage.m_strFileTitle2;
		m_strFilePath3 = ps.m_SecondPage.m_strFilePath3;
		m_strFileTitle3 = ps.m_SecondPage.m_strFileTitle3;
		m_strFilePath4 = ps.m_SecondPage.m_strFilePath4;
		m_strFileTitle4 = ps.m_SecondPage.m_strFileTitle4;
		m_strFilePath5 = ps.m_SecondPage.m_strFilePath5;
		m_strFileTitle5 = ps.m_SecondPage.m_strFileTitle5;
		m_strFilePath6 = ps.m_SecondPage.m_strFilePath6;
		m_strFileTitle6 = ps.m_SecondPage.m_strFileTitle6;
		m_strFilePath7 = ps.m_SecondPage.m_strFilePath7;
		m_strFileTitle7 = ps.m_SecondPage.m_strFileTitle7;
		m_strFilePath8 = ps.m_SecondPage.m_strFilePath8;
		m_strFileTitle8 = ps.m_SecondPage.m_strFileTitle8;
		m_strFilePath9 = ps.m_SecondPage.m_strFilePath9;
		m_strFileTitle9 = ps.m_SecondPage.m_strFileTitle9;
	}	

	//////////////////////////////////
	//  This needs additional work to reflect actual port state

	m_wndView.bComPortSelected = FALSE;
	m_wndView.bPropertiesBoxShown = TRUE;
	m_wndView.Invalidate();
}

void CMainFrame::OnFontColor() 
{
	CPropComColorDialog dlgFontColor(RGB(0, 0, 0), 
		CC_RGBINIT, NULL, "Font Color");
	
	if(dlgFontColor.DoModal()  == IDOK)
	{
		m_clrFontColor = dlgFontColor.GetColor();
		cfText.crTextColor = m_clrFontColor;

		CRichEditCtrl* p_wndInputRichEditCtrl;
		p_wndInputRichEditCtrl = (CRichEditCtrl*)m_wndInputDlgBar.GetDlgItem(IDC_TERMINAL_INPUT);
		p_wndInputRichEditCtrl->SetDefaultCharFormat(cfText);

		m_wndView.m_wndOutputRichEditCtrl.SetDefaultCharFormat(cfText);
	}	
}

void CMainFrame::OnUpdateFontColor(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnBackgroundColor() 
{
	CPropComColorDialog dlgBackgroundColor(RGB(255, 255, 255), 
		CC_RGBINIT, NULL, "Background Color");
	
	if(dlgBackgroundColor.DoModal()  == IDOK)
	{
		m_clrBackgroundColor = dlgBackgroundColor.GetColor();

		CRichEditCtrl* p_wndInputRichEditCtrl;
		p_wndInputRichEditCtrl = (CRichEditCtrl*)m_wndInputDlgBar.GetDlgItem(IDC_TERMINAL_INPUT);
		p_wndInputRichEditCtrl->SetBackgroundColor(FALSE, m_clrBackgroundColor);

		m_wndView.m_wndOutputRichEditCtrl.SetBackgroundColor(FALSE, m_clrBackgroundColor);
	}	
}

void CMainFrame::OnUpdateBackgroundColor(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnNewTerminal() 
{
	TCHAR szModuleFileName[MAX_PATH] = _T("");

	GetModuleFileName(GetModuleHandle(NULL), szModuleFileName, MAX_PATH);

	ShellExecute(NULL, _T("open"), (LPCTSTR)szModuleFileName, NULL, 0, SW_SHOWNORMAL);
}

void CMainFrame::OnUpdateNewTerminal(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnSendfile() 
{
}

void CMainFrame::OnUpdateSendfile(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}	
}

void CMainFrame::OnSendBreak() 
{
}

void CMainFrame::OnUpdateSendBreak(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}	
}

void CMainFrame::OnStop() 
{
}

void CMainFrame::OnUpdateStop(CCmdUI* pCmdUI) 
{
	if(bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}	
}

void CMainFrame::OnRun1() 
{
}

void CMainFrame::OnUpdateRun1(CCmdUI* pCmdUI) 
{
	if(m_strFileTitle1 == "" || bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnRun2() 
{
}

void CMainFrame::OnUpdateRun2(CCmdUI* pCmdUI) 
{
	if(m_strFileTitle2 == "" || bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnRun3() 
{
}

void CMainFrame::OnUpdateRun3(CCmdUI* pCmdUI) 
{
	if(m_strFileTitle3 == "" || bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnRun4() 
{
}

void CMainFrame::OnUpdateRun4(CCmdUI* pCmdUI) 
{
	if(m_strFileTitle4 == "" || bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnRun5() 
{
}

void CMainFrame::OnUpdateRun5(CCmdUI* pCmdUI) 
{
	if(m_strFileTitle5 == "" || bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnRun6() 
{
}

void CMainFrame::OnUpdateRun6(CCmdUI* pCmdUI) 
{
	if(m_strFileTitle6 == "" || bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnRun7() 
{
}

void CMainFrame::OnUpdateRun7(CCmdUI* pCmdUI) 
{
	if(m_strFileTitle7 == "" || bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnRun8() 
{
}

void CMainFrame::OnUpdateRun8(CCmdUI* pCmdUI) 
{
	if(m_strFileTitle8 == "" || bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnRun9() 
{
}

void CMainFrame::OnUpdateRun9(CCmdUI* pCmdUI) 
{
	if(m_strFileTitle9 == "" || bComPortSelected == FALSE)
	{		
		pCmdUI->Enable(FALSE);	
	}
	else
	{		
		pCmdUI->Enable(TRUE);
	}
}