// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__239D199A_9C5D_425A_A7F0_F6DD1E4235C1__INCLUDED_)
#define AFX_MAINFRM_H__239D199A_9C5D_425A_A7F0_F6DD1E4235C1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChildView.h"
#include "TerminalInputBar.h"
#include "PropPinStateBar.h"
#include "PropComPropertySheet.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
public:
	COLORREF m_clrFontColor;
	COLORREF m_clrBackgroundColor;
	CHARFORMAT cfText;
// Operations
public:
	BOOL bToolbarsCreated;
	BOOL bShowPinStateDlgBar;
	BOOL bShowMultiFileBar;

	BOOL bStopEnabled;

	BOOL bComPortSelected;

	CString m_strFilePath1;
	CString m_strFileTitle1;
	CString m_strFilePath2;
	CString m_strFileTitle2;
	CString m_strFilePath3;
	CString m_strFileTitle3;
	CString m_strFilePath4;
	CString m_strFileTitle4;
	CString m_strFilePath5;
	CString m_strFileTitle5;
	CString m_strFilePath6;
	CString m_strFileTitle6;
	CString m_strFilePath7;
	CString m_strFileTitle7;
	CString m_strFilePath8;
	CString m_strFileTitle8;
	CString m_strFilePath9;
	CString m_strFileTitle9;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	virtual void RecalcLayout(BOOL bNotify = TRUE);
	//}}AFX_VIRTUAL

// Implementation
public:
	void StartupConfigureSettings();
	BOOL OnToolTipNotify(UINT id, NMHDR* pNMHDR, LRESULT* pResult);
	void UpdatePinState(UINT nID, int nState);

	void UpdatePin0(int nState);
	void UpdatePin1(int nState);
	void UpdatePin2(int nState);
	void UpdatePin3(int nState);
	void UpdatePin4(int nState);
	void UpdatePin5(int nState);
	void UpdatePin6(int nState);
	void UpdatePin7(int nState);
	void UpdatePin8(int nState);
	void UpdatePin9(int nState);
	void UpdatePin10(int nState);
	void UpdatePin11(int nState);
	void UpdatePin12(int nState);
	void UpdatePin13(int nState);
	void UpdatePin14(int nState);
	void UpdatePin15(int nState);
	void UpdatePin16(int nState);
	void UpdatePin17(int nState);
	void UpdatePin18(int nState);
	void UpdatePin19(int nState);
	void UpdatePin20(int nState);
	void UpdatePin21(int nState);
	void UpdatePin22(int nState);
	void UpdatePin23(int nState);
	void UpdatePin24(int nState);
	void UpdatePin25(int nState);
	void UpdatePin26(int nState);
	void UpdatePin27(int nState);
	void UpdatePin28(int nState);
	void UpdatePin29(int nState);
	void UpdatePin30(int nState);
	void UpdatePin31(int nState);

	virtual ~CMainFrame();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar			m_wndStatusBar;
	CToolBar			m_wndToolBar;
	CToolBar			m_wndMultiFileBar;
	CChildView			m_wndView;	
	CReBar				m_wndReBar;	
	CTerminalInputBar	m_wndInputDlgBar;
	CPropPinStateBar	m_wndPinStateDlgBar;	

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnSendfile();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnFilePrint();
	afx_msg void OnNewTerminal();
	afx_msg void OnSendBreak();
	afx_msg void OnFontColor();
	afx_msg void OnBackgroundColor();
	afx_msg void OnOpenCliplist();
	afx_msg void OnClearInput();
	afx_msg void OnClearOutput();
	afx_msg void OnViewPinStatusBar();
	afx_msg void OnUpdateViewPinStatusBar(CCmdUI* pCmdUI);
	afx_msg void OnEditFind();
	afx_msg void OnStop();
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnRun1();
	afx_msg void OnRun2();
	afx_msg void OnRun3();
	afx_msg void OnRun4();
	afx_msg void OnRun5();
	afx_msg void OnRun6();
	afx_msg void OnRun7();
	afx_msg void OnRun8();
	afx_msg void OnRun9();
	afx_msg void OnViewMultifileBar();
	afx_msg void OnUpdateViewMultifileBar(CCmdUI* pCmdUI);
	afx_msg void OnConfigureSettings();
	afx_msg void OnOpenDifferentPort();
	afx_msg void OnUpdateStop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRun1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRun2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRun3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRun4(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRun5(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRun6(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRun7(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRun8(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRun9(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOpenCliplist(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditFind(CCmdUI* pCmdUI);
	afx_msg void OnUpdateClearInput(CCmdUI* pCmdUI);
	afx_msg void OnUpdateClearOutput(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFontColor(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBackgroundColor(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSendBreak(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSendfile(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNewTerminal(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg LRESULT OnFindReplace(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__239D199A_9C5D_425A_A7F0_F6DD1E4235C1__INCLUDED_)
